#notification

**Overview**  
アプリにPush Notificationを送る

## One Signal

**[ONE SIGNAL](https://onesignal.com/)にログイン**

> user : marketing@freep.co.jp  
> pass : S3jai5sK8v + キーワード

### アプリ生成
「Add a new app」よりアプリを登録

##Android

### Generating a GCM Push Notification Key 

1. [https://console.developers.google.com/project](https://console.developers.google.com/project)よりプロジェクト生成。（既にアプリ生成済みの場合はアプリを選択）

1. 画面上部の「プロジェクト番号」取得
2. 画面左のメニュー > APIと認証 > API > Mobile APIs > Cloud Messaging For Android > APIを有効にする
![](https://dl.pushbulletusercontent.com/zwVkpa5AIogZwLkNmnMR7PBfmCUEVw3z/%E3%82%B9%E3%82%AF%E3%83%AA%E3%83%BC%E3%83%B3%E3%82%B7%E3%83%A7%E3%83%83%E3%83%88%202015-07-29%2010.58.33.png)
3. 画面左のメニュー > APIと認証 > 認証 > 新しいキーを生成 > サーバーキー生成 > 書き込むエリアは空で生成する
4. 生成した「サーバーアプリケーションのキー」をコピーしOne Signalに登録

##iOS

1. キーチェーンアクセス > 証明アシスタント > 認証局に証明書を要求 > 情報記載し証明書発行（ディスクに保存）
![](https://dl.pushbulletusercontent.com/hLXAZasTcfhRhrex3ZS5fyi2SnqYgj5r/%E3%82%B9%E3%82%AF%E3%83%AA%E3%83%BC%E3%83%B3%E3%82%B7%E3%83%A7%E3%83%83%E3%83%88%202015-07-29%2011.23.52.png)
2. [iOS Dev Center](https://developer.apple.com/) > Certificates, Identifiers & Profiles > Identifiers > App IDs よりアプリを選びEditを選択
3. Push Notificationsにチェックを付ける
4. 出てきた質問に対してContinueを選択
5. 先ほど生成したCSRをアップロードし Generateを選択
![](https://dl.pushbulletusercontent.com/PtP7ngRKMv3QsEbmHgsmjKdjZBf6Eqls/%E3%82%B9%E3%82%AF%E3%83%AA%E3%83%BC%E3%83%B3%E3%82%B7%E3%83%A7%E3%83%83%E3%83%88%202015-07-29%2011.34.22.png)
6. 生成されたcertificateをDownloadし、ダブルクリックしキーチェーンに保存する
7. キーチェーンアクセス（左は上：ログイン、下：鍵を選択）から先ほど追加した鍵を書き出す
![](https://dl.pushbulletusercontent.com/tKj8FiwlLtA9uyyBVBIhVguubC9fhiGZ/%E3%82%B9%E3%82%AF%E3%83%AA%E3%83%BC%E3%83%B3%E3%82%B7%E3%83%A7%E3%83%83%E3%83%88%202015-07-29%2011.48.41.png)
8. 書き出す際の名前は**アプリ名\_certificates_pistribution.p12**にする（実際はなんでも良い）。パスワードも設定。（後ほど利用）
9. One SignalのiOSの設定で生成下p12をアップロード。パスワードは上記で書いたパスワード
10. iOS Devcenterよりprobisioing profileをダウンロードし直す

## CoronaSDKの設定
1. アプリをビルドするアカウントでCorona Labsにログインする
1. [Corona Plugin](https://store.coronalabs.com/plugin/onesignal)よりOneSignalのFreeボタンを押しcheckoutする

## コードの設定

### build.settingに以下のコードを挿入する

```
plugins =
{
    ["plugin.OneSignal"] =
    {
        publisherId = "com.onesignal",
    },
    ["plugin.google.play.services"] =
    {
        publisherId = "com.coronalabs",
        supportedPlatforms = { android=true, ["android-kindle"]=true },
    },
}
```
```
UIBackgroundModes = {"remote-notification"},
```

### アプリ側に実装

ApplicationKeyとGoogle Project numberを設定